#!/usr/local/bin/perl -wT

($#ARGV==6) || ($#ARGV==5) || die "Usage: $0 -d <datadir> -f <source> -s|-u <from> <to>\n";

my $dflag = shift;
if ($dflag =~ /^(\-d)$/) { $dflag = $1; } 
else { die "Usage: $0 -d <datadir> -f <source> -s|-u <from> <to>"; }
my $datadir = shift;

my $fflag = shift;
if ($fflag =~ /^(\-f)$/) { $fflag = $1; } 
else { die "Usage: $0 -d <datadir> -f <source> -s|-u <from> <to>"; }
my $source = shift; 

my $tmp = shift; 
if ($tmp =~ /^\-s$/) { 
    $sorted = 1;
} elsif ($tmp =~ /^\-u$/) {
    $sorted = 0;
} else {
    die "Usage: $0 -d <datadir> -f <source> -s|-u <from> <to>";
}

#unshift(@ARGV, $tmp) if (! $sorted);
my $start = shift;
my $end = shift;

(-d $datadir) || die "$datadir: Not a directory.";
($start =~ /^\d+$/) || die "$start: Numerical format required.";
($end =~ /^\d+$/) || die "$end: Numerical format required.";

open(XLAND, "$datadir/$source.annot.links") || die "Could not open landmarks file."; 

while (<XLAND>) {
   next if /^#/;     # comment
   (($code) = /^([A-Z][A-Z])\s+/) || die "Not landmarks format.";

   ($code eq "GN") || ($code eq "PR") || ($code eq "PB") ||
   ($code eq "XR") || ($code eq "XP") || ($code eq "XO") || 
   ($code eq "XG") || ($code eq "XC") || ($code eq "XX") ||
   ($code eq "XS") || 
          die "Unrecognized line code.";
   
   if (($code eq "GN") || ($code eq "PR") || ($code eq "PB")) {
      (($code, $from, $to, $src) = 
       /^([A-Z][A-Z])\s+(\d+)\s+(\d+).+\s+(\w+)\s+\([^\)]*\)\s*\n$/) ||
          die "Not a landmark format.";  
      if ($sorted == 1) {
          next if (($src ne $source) || ($to<$start));
          last if ($from > $end);
      } else {
          next if (($src ne $source) || ($end<$from) || ($to<$start));
      }

      ($xfrom, $xto) = &overlaps($from, $to);
#     print "<<$xfrom, $xto>>";
      $_ =~ s/^([A-Z][A-Z]\s+)$from(\s+)$to(\s+)/$1$xfrom$2$xto$3/;
      chop;
      print "$_\n";
   }
} 

1;    # return value if successful

# ----- subroutines ------

sub overlaps      # from to 
{      
    local($from,$to) = @_;  
    local($xfrom,$xto);

    $xfrom = ($start > $from) ? $start:$from;
    $xto = ($end < $to) ? $end:$to;
#   print "start $start end $end from $from to $to xfrom $xfrom xto $xto\n";

    ($xfrom, $xto);
}
