#!/usr/local/bin/perl -wT

($#ARGV==2) || die "Usage: $0 <seq_file> <offset> <model_system>";

my $seqname = shift;
my $offset = shift;
$offset--;
my $model = shift;
 
while (<>) { last if (/^#:lat\s*\n$/); }
!eof || die "Not an #lat alignment format."; 
print "#:lat\n";

open(ALIAS, ">alias") || die "Could not open aliases file for writing."; 
open(LEAF, ">leaves") || die "Could not open leaf-data file for writing.";

@aliases = ();
while (<>) {
   if (/^s \{\s*\n$/) {
      print $_;
      while (<>) {
         if (/^\}\s*\n$/) { print $_; last; }
         (($organism, $from, $to) = /^\"(\w\.\w+)\"\s*(\d+)\s*(\d+)\s*\n$/) or 
                        die "Not lav format"; 
#--------if (/^\"$seqname\"\s*(\d+)\s*(\d+)\s*\n$/)  {
         if ($organism eq $seqname) {
             $from = $from + $offset;
             $to = $to + $offset;
             print "\"$seqname\" $from $to\n";
             print LEAF "$seqname $from $to\n";
             ($organism =~ /^\w\.(\w+)$/) || die;
             if (defined($count{$organism})) { 
                 $tmp = ++$count{$organism};
                 push(@aliases, "\"$1.$tmp\"".pdflink($organism,$model)); 
             } else {
                 $count{$organism} = 0;
                 push(@aliases, "\"$1\"".pdflink($organism,$model));
             }
         } else {
             print $_;
             ($organism =~ /^\w\.(\w+)$/) || die;
             print LEAF "$organism $from $to\n";
             if (defined($count{$organism})) {
                 $tmp = ++$count{$organism};  
                 push(@aliases, "\"$1.$tmp\"".pdflink($organism,$model));
             } else {
                 $count{$organism} = 0;
                 push(@aliases, "\"$1\"".pdflink($organism,$model));
             }
         }   
      }
   } else {
      print $_;
   } 
}
$alias_list = join(",\n", @aliases);
print ALIAS $alias_list; 

close(ALIAS) || die;
close(LEAF) || die;

sub pdflink # organism model
{
    my ($bug_file, $model) = @_;
    my ($bug, $contig, $ori, $from, $to, $idx);
    if ($bug_file eq $seqname) { return ""; }

    open (F, "<$bug_file") || die "Could not open sequence file $bug_file.";

    ($bug_file) = ($bug_file =~ /^\S*\.(\S+)$/);
    $bug_file =~ tr/[a-z]/[A-Z]/;

    $_ = <F>;
    chop;
    if ((($bug, $from, $to, $ori, $contig, $rest) = /^>(\S+):\s+(\d+)\s*\-\s*(\d+)\s*(of reverse complement)?\s+of\s+(>\S+)\s*(\S.*)?$/) && ($bug eq $bug_file)) {
        # recognized "menteric" file header format
        if (defined($ori)) { $ori = "reverse complement"; }
        else {$ori = "forward"; }
     
        if (defined($rest)) { ($idx) = ($rest =~ /^\(AN\s+(\-?\d+)\)/); }
        if (defined($idx)) { 
            close(F);
            return " link \"http://www.your_address.edu/cgi-bin/cgi-extract-contig/query?org=$bug&contig=$contig&idx=$idx&from=$from&to=$to&m=$model\""; }
        else { 
            close(F);
            return " link \"http://www.your_address.edu/cgi-bin/cgi-extract-contig/query?org=$bug&contig=$contig&idx=-1&from=$from&to=$to&m=$model\""; 
        }
    } else {
        # unrecognized header format 
        close(F); return "";
    }

    close(F); return "";
}
