#!/bin/ksh -ue

FROM=${1:?}
TO=${2:?}
GSYSTEM=${3:?}
((LEN = $TO-$FROM+1))

. /usr/local/menteric/lib/${GSYSTEM}.set-globals

print "$FROM $TO" > .data

#warn +make_alignment "$1" "$2"

# prefix="s." -> create s.eco, s.kpn, etc

call_align5 ()
{
    somefiles=$(ls s.* 2>/dev/null)
    if (( ${#somefiles} != 0 ))
    then 
      if [[ -e $DER_DATA/$ALIAS_LIST ]]
      then
        aliases=""
        while read line
        do
           if [[ -e $line ]]
           then
           aliases="$aliases $line"
           fi
        done < $DER_DATA/$ALIAS_LIST
      else
        aliases=$somefiles
      fi  
      align5 -b  "miniblastz O=$OVALUE K=$KVALUE" -s 4  r.$PRINC_ALIAS $aliases > tmp.a
    fi
    rm -f  "*.alignt"
}

extract_indexed_region "$1" "$2" $ALIAS_FILE -d $DER_DATA -b $BAS_DATA -p "s." &&
dna "$1,$2" $BAS_DATA/$PRINC_SEQ > r.$PRINC_ALIAS &&
call_align5 && 
mv r.$PRINC_ALIAS r.$PRINC_ALIAS~ &&
ln -s $BAS_DATA/$PRINC_SEQ r.$PRINC_ALIAS &&
(
if [[ -e tmp.a ]] 
then ali_add_offset r.$PRINC_ALIAS $1 $GSYSTEM <tmp.a >ali 
fi
) &&
( 
if [[ ! -s ali ]]  
then  
cat <<! >alias
"$PRINC_ALIAS"
!
    
cat <<! >leaves
r.$PRINC_ALIAS $1 $2
!

cat <<! >ali
#:lat

d {
 "No alignment found: r.$PRINC_ALIAS"
}
s {
"r.$PRINC_ALIAS" $FROM $TO
}
a {
 s 0
 b 1
 e $LEN 
 l $LEN
}
!
fi
)
#maps ali -j -n "r.$PRINC_ALIAS" > txt
